try:
    import indigo
except ImportError:
    raise ImportError("Indigo Python scripts can only be executed from within Indigo's Execute Script action")
import traceback

def processVariable(theInputVariable):
    if isinstance(theInputVariable, indigo.Variable):
        var = theInputVariable
    else:
        try:
            var = _getIndigoObject(indigo.variables, theInputVariable)
        except Exception, e:
            indigo.server.log("variable error: %s\n%s" % (str(e), traceback.format_exc(10)), type="Variable Watcher", isError=True)
            return
    try:
        nextVar = _getIndigoObject(indigo.variables, var.value)
        processVariable(nextVar)
    except Exception, e:
        try:
            actionGroup = _getIndigoObject(indigo.actionGroups, var.value)
            indigo.actionGroup.execute(actionGroup)
        except Exception, e:
            indigo.server.log("action group execution error: %s\n%s" % (str(e), traceback.format_exc(10)), type="Variable Watcher", isError=True)

def _getIndigoObject(objectList, input):
    try:
        inputInt = int(input)
        try:
            theObject = objectList[inputInt]
        except:
            raise KeyError("object id %i not found in database" % inputInt)
    except Exception, e:
        if isinstance(input, str) or isinstance(input, unicode):
            try:
                theObject = objectList[input]
            except:
                raise KeyError("object named '%s' not found in database" % input)
        else:
            raise e
    return theObject